#ifndef GETCH_H_INCLUDED
#define GETCH_H_INCLUDED

#include <stdio.h>
#include <termios.h>
#include <unistd.h>

int getch(){
    struct termios oldt, newt;
    int ch;
    tcgetattr( STDIN_FILENO, &oldt );
    newt = oldt;
    newt.c_lflag &= ~( ICANON | ECHO );
    tcsetattr( STDIN_FILENO, TCSANOW, &newt );
    ch = getchar();
    tcsetattr( STDIN_FILENO, TCSANOW, &oldt );
    return ch;
}

void clpuf(void)
 {
 while (getc(stdin) != '\n')
    ;
 }

#endif // GETCH_H_INCLUDED
