#include <iostream>
#include "talarius.h"
#include <stdlib.h> //wegen rand und srand
#include <stdio.h> // wegen fopen
#include <fcntl.h>  // wegen open
#include <errno.h>  // wegen errno
#include <unistd.h> // wegen close
#include "dos_fcntl.h"

using namespace std;

// Konstruktor
Talarius::Talarius(void)
{
int i = 0;
initrandom = 0;
toprange = 64;
kodieren = 0;
untergrenze = zeimen = dummy = 0;
zuzaar = new unsigned int[132000]; // 2200 Byte auf dem Heap allozieren
schluessel = new unsigned int[132000]; // 2200 Byte auf dem Heap allozieren
wuerfel = new unsigned int[132000]; // 2200 Byte auf dem Heap allozieren
fehlbytes = new int[132000];
satzgecodet = new unsigned char[132000];
satzteil = new unsigned char[132000];
unkodiert = new unsigned char[132000];
kodiert = new unsigned char[132000];
for (i = 0; i < 150; i++)
 {
  quelldatei[i] = '\0';
  zieldatei[i]= '\0';
  datname[i] = '\0';
  keyfilename[i] = '\0';
 }
};

/** Zeigt Hauptmenue an*/
void Talarius::Hauptmenue(void)
{
cout << endl << endl << "Talarius, einfaches Verschuesselungsprogramm" << endl;
cout << "Toprange: " << toprange << endl;
cout << "initrandom = 0" << endl;
cout << "Programmende.........0    Key-Datei einlesen..5" << endl;
cout << "Obergrenze eingeben..1    Dateilänge zeigen...6" << endl;
cout << "Zahlen generieren....2    SRCDatei einlesen...7" << endl;
cout << "Key-Datei sichern....3    Datei kodieren......8" << endl;
cout << "Zeige Key-arreal.....4    Datei dekodieren....9" << endl;
cout << "Eingelesene Key-Datei zu Ur-Array übertragen..10" << endl;
cout << endl;
};

// Destruktor
Talarius::~Talarius(void)
{
delete zuzaar;
delete schluessel;
delete wuerfel;
delete fehlbytes;
delete satzgecodet;
delete satzteil;
delete unkodiert;
delete kodiert;
};

/**Setzt die Permutationstiefe */
int Talarius::setToprange(void)
{
  int wohin = 1;
  cout << "\nVerschlüsselungstiefe: ";
  cout << "\nHauptmenue.........1";
  cout << "\nObergrenze= 8......2";
  cout << "\nObergrenze= 16.....3";
  cout << "\nObergrenze= 32.....4";
  cout << "\nObergrenze= 64.....5";
  cout << "\nObergrenze= 128....6";
  cout << "\nObergrenze= 256....7";
  cout << "\nObergrenze= 512....8";
  cout << "\nObergrenze= 1024...9";
  cout << "\nObergrenze= 2048...10";
  cout << "\nObergrenze= 4096...11";
  cout << "\nObergrenze= 8192...12";
  cout << "\nObergrenze= 16384..13";
  cout << "\nObergrenze= 32768..14";
  cout << "\nIhre Wahl: ";
  cin >> wohin;
  if(wohin == 1 )  return toprange; //goto fertig;
  if(wohin == 2 )  toprange = 8;
  if(wohin == 3 )  toprange = 16;
  if(wohin == 4 )  toprange = 32;
  if(wohin == 5 )  toprange = 64;
  if(wohin == 6 )  toprange = 128;
  if(wohin == 7 )  toprange = 256;
  if(wohin == 8 )  toprange = 512;
  if(wohin == 9 )  toprange = 1024;
  if(wohin == 10)  toprange = 2048;
  if(wohin == 11)  toprange = 4096;
  if(wohin == 12)  toprange = 8192;
  if(wohin == 13)  toprange = 16384;
  if(wohin == 14)  toprange = 32768;
  if (toprange > 32768) toprange = 32768; // Sichert vor falschen Eingaben
  cout << endl << "Neue Obergrenze: " << toprange << endl;

return toprange;
}

/** Fragt ab, ob kodiert oder dekodiert werden soll */
void Talarius::KodierFrage(void)
{
  cout << "\nKodieren = 0    dekodieren = 1";
  cout << "\nBitte Modus eingeben: ";
  cin >> kodieren;

  if ((kodieren < 0) || (kodieren > 1))
   {
    cout << endl << " Falsche Eingabe: Nur 0 der 1 erlaubt";
    kodieren = 0;
   }
  cout <<"\nModus: ";
  if (kodieren == 0)  cout << "kodieren";
   else               cout << "dekodieren";
}

/** Liest den Namen der Schlüsseldatei ein*/
void Talarius::GetKeyDateiname(void)
{
 cout << "\nBitte Name der Schlüsseldatei eingeben: ";
 cin >> keyfilename;
}

/** Zeigt den Namen der Schlüsseldatei*/
void Talarius::showKeyfilename(void)
{
 cout << "\nLänge der Schlüsseldatei: " << keyfilename << ": " << keyfilelength << " Bytes" << endl;
}

/**  Liest Namen der Quelldatei, Zieldate ein*/
int Talarius::getfilnames(int abfragemodus)
{
 int wohin = 0;
   cout << "_______________" << endl;
   if (abfragemodus == 0)
    {
     cout << endl << "Bitte Quell-Dateiname eingeben: ";
     cout << "Quelldatei: " << quelldatei << endl;
     cin >> quelldatei;
    }
   cout << endl << "Bitte Ziel-Dateiname eingeben: ";
   cin >> zieldatei;
   cout << endl << "Gewählte Dateien: " << endl;
   cout << "Quelldatei: " << quelldatei << endl;
   cout << "Zieldatei.: " << zieldatei << endl ;
   cout << "_______________" << endl;
   cout << endl << "Mit Wahl einverstanden(Ja = 1 / abbrechen = 0)?";
   cin >> wohin;

   if ((wohin < 0) || (wohin > 1))
    {
    cout << "Falsche Eingabe: " << endl;
    wohin = 0;
    }

return(wohin);
}

 /** generiert Zufallszahlen von 1 bis 32767 */
 int Talarius::getrand(int min, int max)
{
int zuza, zuza2, zuza3, rewer;
// bis 32767
 //srand (time (NULL));
 if (initrandom == 0)
  {
  srand (time (NULL));
  initrandom = 1;
  }

zuza  = rand();
zuza2 = (max - min); // + 1);
zuza3 = zuza % zuza2;
rewer = zuza3 + min;
return rewer;
}
/** alt war long als Rückgabewert generiert Zufallszahlen größer als 32768 */
int Talarius::longrand(long minimum, long maximum)
{
 int rewer = 0, zuza = 0;
 int bereich, bereichsfeld, limit = 0;

  if(maximum > 32767)
  {
   bereichsfeld = maximum / 32768;

   bereich = getrand(0, bereichsfeld);
   if (bereich > 0)
    {
     rewer = 32767 * (long)bereich;  // bereich: 0 = 0-> 32767, 1 = 32768 - 65535, 2 = 65536 - 98303
     limit = maximum - rewer;
     zuza = getrand(0, limit);
     rewer += zuza;
    }
    else rewer = (long)getrand(0, 32767);
  }
  else rewer = (long)getrand(0, (int)maximum);

 return(rewer);
}


/** Initialisiert das Urarreal mit Zahlen von 0 bis toprange -1 */
void Talarius::initarreale(void)
{
int slei;
if (toprange > 32768) toprange = 32768;

 // Setzt das Arreal wuerfel auf NULL
 for (slei = 0; slei < toprange; slei++)
   wuerfel[slei] = 0;

 for (slei = 0; slei < toprange; slei++)
  {
   zuzaar[slei] = 0;
   wuerfel[slei] = slei; // Initialisiert das Array wuerfel mit Zahlen von 0 bis toprange -1
   schluessel[slei] = 0;
  }

}

/** Errechnet die Summe aller Elemente des Zufallszahlenarreals "schluessel" */
void Talarius::testeareal(void)
{
unsigned int slei, dummy = 0, erge = 0;

for (slei = 0; slei < (unsigned int)toprange; slei++)
 {
  dummy += slei;
  erge += schluessel[slei];
 }
cout << endl << "Anzahl: "<< toprange << " Schlüssel: " << erge << "  Testwert: " << dummy << endl;
}

/** Kopiert den Dateinamen in dateiname zur Variable datname */
void Talarius::CopyToDatname(char dateiname[])
{
 int slei = 0;
 while((dateiname[slei]) != '\0')
  {
   datname[slei] = dateiname[slei];
   slei++;
  }
}
/** Ermittelt die Länge der Datei mit der Nummer welchedatei */
long Talarius::getdatlen(int welchedatei)
{
  int fh;
  long rewer = 0L;
  if (welchedatei == 1) { cout << "Ermittle Länge der Quelldatei" << endl; CopyToDatname(quelldatei); }
  if (welchedatei == 2) { cout << "Ermittle Länge der Quelldatei" << endl; CopyToDatname(zieldatei); }
  if (welchedatei == 3) { cout << "Ermittle Länge der Quelldatei" << endl; CopyToDatname(keyfilename); }

  if( (fh = open( datname, _O_RDONLY | _O_BINARY ) ) == -1 )
   {
    rewer = errno;
    return -1;
   }
   else
   {
    rewer = lseek(fh, 0, SEEK_END);
    close( fh );
    dateilaenge = rewer;
    cout << "Ermittlete Dateilänge: " << dateilaenge << " Bytes" << endl;
   }
 return(dateilaenge);
}

int Talarius::gettoprange(void)
{
return toprange;
}

/** Speichert Parameter 1 in Variable toprange */
void Talarius::settoprange(int og)
{
  toprange = og;
}

/** Überträgt zuerst per Schlüssel das Arreal wuerfel nach Schlüssel-Arreal
  * Kuerzt nach jeder generierten Zahl das Ur-Array */
void Talarius::kuerzearreal(int zuza)
{
int slei;
          //stelle
schluessel[sleia] = wuerfel[zuza];
for (slei = zuza; slei < toprange; slei++)
 wuerfel[slei] = wuerfel [slei + 1];

}

/** Zeigt die Zahlen des Zufallszahlenarrys auf */
void Talarius::zeigezahlen(int zuzaar[], int zuzalimit, char (*titel))
{
int zeize = 0, slei;
cout << "\n" << titel << " von 1 bis " << zuzalimit << endl;

 for (slei = 0; slei < zuzalimit; slei++)
  {
  cout  << "Nr." << slei << "= " <<  zuzaar[slei];
  zeize++;
  if (zeize >= 6) { cout << "\n"; zeize = 0; }
  }
}

/** Zeigt Schlüsselarreal auf. Nur bei kleinen toprange-Werten sinnvoll */
void Talarius::zeigearreal()
{
 int slei;

 cout << "\nZeige Permutiertes Arreal\n";

 for (slei = 0; slei < toprange; slei++)
  cout << " " << schluessel[slei] << " ";
 }

/** Generiert die fehlenden Bytes, um die nötige Dateilänge zum Verschlüsseln zu erhalten*/
int Talarius::GenRandomByts(void)
{
int slei, rewer = 0;

 for (slei = 0; slei < blockdifferenz; slei++)
  {
   fehlbytes[slei]  = getrand(0, 255);
   rewer++;
  }
return rewer;
}
/**rundet Datei auf richtige Länge auf */
int Talarius::SetDifBytesInFile(void)
{
 int slei;
 FILE *ziel;
 int rewer = -1;

  if ((ziel = fopen(datname, "ab"))  == NULL)
   {
    rewer = 0; // bei Fehler eine 0 als Rückgabewert, bei Erfolg eine -1;
    return -1;
   }
   else
    {
     fseek(ziel, 0, SEEK_END); //setzt Dateizeiger auf 4 Bytes vor Dateiende
     // Speichert die fehlenden Bytes als int-Wert in datnamedas rgdatlenarray
     for (slei = 0; slei < blockdifferenz; slei++)
      fputc((int)fehlbytes[slei], ziel);
    }

fclose(ziel);

return(rewer);
}


/** Schreibt den Schlüssel in eine Datei*/
int Talarius::schreibedatei(void)
{
  //Talarius taurus;
  FILE *fz;
  int slei, sleib;
  unsigned char intteile[4];
  zeimen = 0;
   fz = fopen(keyfilename, "wb");
   if (fz == NULL)
    {
     cout << "\nDatei " << keyfilename << " kann nicht erstellt werden." ;
     return -1;
    }
    else
    {
     cout << endl;
     for (slei = 0; slei < toprange; slei++)
      {
       intzuchar(schluessel[slei], &intteile);
       for (sleib = 0; sleib <= 3; sleib++)
        {
         //cout << intteile[sleib] << " ";
         fputc(intteile[sleib], fz);
         zeimen++;
        }
      }
     }
  cout << endl << "Es wurden " << zeimen << " Zeichen geschrieben." << endl;
  fclose(fz);
  cout << "Datei wurde geschlossen" << endl;
  cout << "Ende Dateischreiben von " << keyfilename << endl;
      /* Rückgabewert ist die Anzahl der geschreibenen Zeichen*/

 return zeimen;
}

/** Liest die Schlüsseldatei ein */
int Talarius::lesedateiein(void)
{
  //Talarius taurus;
  FILE *fz;
  int sleia, slei, sleic = 0, dummy, groesse;
  unsigned int intzahl;
  unsigned char intteile[4];

  groesse = toprange * 4; // Pro in-Wert-4Bytes

   fz = fopen(keyfilename, "rb");
   if (fz == NULL)
    {
     cout << "\nSchlüsseldatei kann nicht geöffnet werden.";
     return sleic;
    }
slei = sleic = 0;
cout << "\nLesegröße: " << groesse << "\n";
for (sleia = 0; sleia < groesse; sleia++)
 {
  dummy = fgetc(fz);
  if (dummy == EOF) break;
 //printf(" *%d* ", dummy);

  intteile[slei++] = dummy;
  if (slei >= 4)
   {
    intzahl = charzuint(intteile);
    //printf( "-c=%d %d=%d- ", sleic, sleia, intzahl);
    schluessel[sleic++] = intzahl;
    slei = 0;
   }
 }

  fclose(fz);
  cout << "\nDatei wurde geschlossen." << endl;
  cout << sleia << " Bytes wurden eingelesen." << endl << sleic << " Zeichen wurden eingelesen" << endl;
  cout << "Ende von Dateieinlesen" << endl;
 return sleic;
}

/**Umwandlung von signed char zu int */
int Talarius::atoint(char letter)
{
 int rewer;
 if ( letter < 0)
  rewer = letter + 256;
   else rewer = (int)letter;
 return rewer;
}

// zerlegt einen long-Wert in vier unsigned int Werte, die dann
// in ein unsigned int Array geschieben werden
void Talarius::DWto4int(unsigned long wd, unsigned int (*DWTeile)[6])
{
 (*DWTeile)[3] = (unsigned int)(wd >> 24);
 (*DWTeile)[2] = (unsigned int)((wd >> 16) & 255);
 (*DWTeile)[1] = (unsigned int)((wd >>  8) & 255);
 (*DWTeile)[0] = (unsigned int)(wd & 255);
}

// setzt aus einem 4int-Array Byte-folgerichtig einen long-Wert zusammen
void Talarius::FourinttoDW(unsigned int DWTeile[], unsigned long (*wd))
{
unsigned long dummy = (unsigned long)DWTeile[0];
dummy += (unsigned long)(DWTeile[1] << 8);
dummy += (unsigned long)(DWTeile[2] << 16);
dummy += (unsigned long)(DWTeile[3] << 24);
(*wd) = dummy;
}

void Talarius::intzuchar(int zuza, unsigned char (*intteile)[4])
{
 (*intteile)[0] = zuza & 255;
 (*intteile)[1] = (zuza & (255 << 8)) >> 8;
 (*intteile)[2] = (zuza & (255 << 16)) >> 16;
 (*intteile)[3] = (zuza & (255 << 24)) >> 24;
}

unsigned int Talarius::charzuint(unsigned char intteile[4])
{
 unsigned int erge = 0;
 erge += intteile[0];
 erge += intteile[1] << 8;
 erge += intteile[2] << 16;
 erge += intteile[3] << 24;

return erge;
}

/** Speichet die Orginaldateilaenge der komprimierten Datei aus einen Long-Wert
 als Anhängsel an die Code-Datei*/
int Talarius::SaveOrgDatlen(unsigned long srcdatlen)
{
Talarius talar;
//unsigned int orgdatlenarray[6];
int rewer = -1;// bei Erfolg -1 , bei existierender Datei -2, sonst 0
FILE *code;

 //DWto4int(srcdatlen, &orgdatlenarray);

	   if ((code = fopen(keyfilename, "ab")) == NULL)
	    {
	     rewer = -2;
	     return -1;
         //goto finito;
	    }
	    else
	    {
         fputDWORD(srcdatlen, code);

         /*
	      fputc((int)orgdatlenarray[3], code);
	      fputc((int)orgdatlenarray[2], code);
          fputc((int)orgdatlenarray[1], code);
	      fputc((int)orgdatlenarray[0], code);
	     */
        fclose(code);
        }
 return(rewer);
}

/** holt nach dem komprimieren aus der Code-Datei die Orginaldateilaenge */
int Talarius::GetOrgDatlen(long (*datlen))
{
  unsigned long datlendummy;
    // MUSS int sein, bei unsigned int kann nicht auf Null dekrementieren!!!
    // dann läuft die Schleife ewig!!!
  FILE *quelle;
  int rewer = -1;

  if ((quelle = fopen(keyfilename, "rb"))  == NULL)
   {
    rewer = 0; // bei Fehler eine 0 als Rückgabewert, bei Erfolg eine -1;
    return(rewer);
   }
   fseek(quelle, -4, SEEK_END); //setzt Dateizeiger auf 4 Bytes vor Dateiende
   // Liest die letzten 4 Bytes als long-Wert
   datlendummy = fgetDWORD(quelle);
   fclose(quelle);

   cout << "\nOrginaldateilänge:   " << datlendummy << " Bytes";

   (*datlen) = datlendummy;

return(rewer);
}



// -----------------------------------------------------------------------
// Die Funktion buzubin wandelt den als int-Wert gegebenen Parameter 1
// in einem Binärwert vom Typ BYTE um. Dieser wird in Parameter 2 als
// String gespeichert. Es werden dabei immer 8 Stellen des Binärwertes
// gezeigt. Das neunte Byte im String dient zur String-Terminierung.
// Aufruf:  buzubin( Char-Wert_als_int, &Binärwert_als_String);

void Talarius::buzubin(unsigned char letter, unsigned char wort[])
{
unsigned int slei, dum;
unsigned int testwert[8] = {128,64,32,16,8,4,2,1};

 for (slei = 0; slei <= 7; slei++)
  {
   dum = letter & testwert[slei];         /* Bit7(128dez) ist auf Char-Nr.0 */
   if (dum != 0)  wort[slei] = '1';
    else          wort[slei] = '0';
   wort[slei+1] = '\0';
  }
}

// Die Funktion binzuza wandelt Binärwerte die als Strings gespeichert sind,
// in Dezimalzahlen um. Die erste Schleife dient zum feststellen der Stringlaenge
// -----------------------------------------------------------------------
void Talarius::binzuza(unsigned int (*letter), unsigned char wort[])
{
unsigned int slei, ende, dumsm, dumza = 0, testwert = 1;

 for (ende = 0; ende <= 8; ende++)
  if (wort[ende] == '\0') break; // Stellt fest, wann String zu Ende ist

 testwert <<= (ende - 1); /* Anpassung von testwert an Stringlaenge */

 for (slei = 0; slei <= (ende - 1); slei++)
  if ((wort[slei] == 'I') || (wort[slei] == '1'))
   {
    dumsm = testwert >> slei;
    dumza += dumsm;
   }
 (*letter) = dumza;
}

// Parameter 1: wenn 1 dann komprimieren, wenn 0 dann dekomprimieren
// Parameter 2: Zufallszahlenarray
// Parameter 3: Zu bearbeitender Eingangsstring;
// Parameter 4: Erstellter Ausgangsstring;
void Talarius::coden(unsigned int key[], unsigned char unkodiert[], unsigned char kodiert[])
{
 long slei, dumwer;

 for (slei = 0; slei < toprange; slei++)
  {
   dumwer = key[slei];
    if (kodieren) kodiert[slei]   = unkodiert[dumwer];
    else          kodiert[dumwer] = unkodiert[slei];
  }
   kodiert[toprange] = '\0';
}


/*---------------Beginn Code-Datei-Erweiterung---------------------------------------*/


/** Wandelt ein Array von int-Werten in einen zusammenhaengenden String von Binaerwerten um */
void Talarius::intToBin(unsigned char quelle[], unsigned char binsatz[])
{
 int slei, dummy, bytenummer, bitnummer; //intdummy
 unsigned char bitval[8] = {128,64,32,16,8,4,2,1};

 for (slei = 0; slei < toprange; slei++)
  {
   bytenummer = slei / 8;
   bitnummer  = slei % 8;
   //intdummy = atoint(quelle[bytenummer]); // Umwandlung von signed char int unsigned int
   dummy = quelle[bytenummer] & bitval[bitnummer];  // Wert Bitweise auslesen
   // Aus den einen zusammenhängenden String zusammenstellen
   if (dummy != 0) { binsatz[slei] = '1';}
    else {       binsatz[slei] = '0';}
   binsatz[slei + 1] = '\0';
  }
}

/** Wandelt ein zusammenhängendes Array von Binärwerten in einzelne Int-Werte um */
void Talarius::binToint(unsigned char binsatz[], unsigned char ziel[16400])
{
 int slei, bytenummer, bitnummer;
 unsigned char bitval[8] = {128,64,32,16,8,4,2,1};
 //Initialisiere das Ziel-Array
 for (slei = 0; slei < toprange; slei++)
  ziel[slei] = 0;

 for (slei = 0; slei < toprange; slei++)
  {
   bytenummer = slei / 8;
   bitnummer  = slei % 8;

   if (binsatz[slei] == '1')
    ziel[bytenummer]= ziel[bytenummer] + bitval[bitnummer];

   //printf("\n%d=%d %d", bytenummer, (*ziel)[bytenummer], bitval[bitnummer]);
  }
//for (slei = 0; slei < toprange / 8; slei++)
// printf("%c", ziel[slei]);
// printf("\nwert[%d]=%d=%c", slei, ziel[slei], ziel[slei]);

}

/** Kodieren der Quell-Datei zur Zieldatei */
int Talarius::loadSRCDatei(void)
{
  // unsigned char satzgecodet[4400];
  //int satz;
  // unsigned char satzteil[4400], unkodiert[4400], kodiert[4400];
  //unsigned char  letter; // quelle war vormals char
  long slei, sleib, zeimen, written;

  // slei + sleib müssen int sein, bei unsigned int kann nicht auf Null dekrementieren!!!
  // sonst läuft die Schleife ewig!!!
  FILE *src, *tar;
  int rewer = -1;

  dateilaenge = getdatlen(1); //Koppiert den Namen der Quelldatei
  //Kodieren = 0    dekodieren = 1
  if (kodieren == 0) cout << "\nDatei " << quelldatei << " kodieren mit " << dateilaenge << "Bytes" << endl;
   else cout << "\nDatei " << quelldatei << " dekodieren mit " << dateilaenge << "Bytes" << endl;

  if ((src = fopen(quelldatei, "rb"))  == NULL)
   {
    cout <<"Quell-Datei kann nicht geöffnet werden";
    rewer = 0; // bei Fehler eine 0 als Rückgabewert, bei Erfolg eine -1;
    return(rewer); //goto finito;
   }
   cout << "Datei " << quelldatei << " mit " << dateilaenge << " Bytes wurde geöffnet....";

   if ((tar = fopen(zieldatei, "wb"))  == NULL)
   {
    cout << "\nZiel-Datei kann nicht erstellt werden";
    fclose(src);
    rewer = 0; // bei Fehler eine 0 als Rückgabewert, bei Erfolg eine -1;
    dummy = rewer;
    return(rewer);
   }

   cout << "\nZieldatei " << zieldatei << "wurde erstellt...." << endl;
   // Speichert die letzten 4 Bytes als long-Wert in das orgdatlenarray
   zeimen = written = 0;
   //satz = 0;

   cout << endl;
   // Speichert die letzten 4 Bytes als long-Wert in das orgdatlenarray
   cout << "\ntoprange / 8: " << toprange / 8 << endl;
   for (slei = 0; slei < dateilaenge; slei+= toprange / 8)
    {
     for (sleib = 0; sleib < toprange / 8; sleib++)
      {
       satzteil[sleib] = (unsigned char)fgetc(src);
        if ( (feof(src)) != 0)
         { //goto eingelesen;
          fclose(src);
          fclose(tar);
          dummy = rewer;
          cout << "\nGelesene Bytes: " << zeimen << "    Geschriebene Bytes: " << written;
            if (kodieren == 1)
             {
              dummy = truncate(zieldatei, orginaldateilaenge);
              cout << endl << "Zieldatei " << zieldatei << " auf " << orginaldateilaenge << " Bytes gesetzt";
             }
            else if (kodieren == 0)
             {
              dummy = truncate(quelldatei, orginaldateilaenge);
              cout << endl << "Quelldatei " << quelldatei << " auf " << orginaldateilaenge << " Bytes gesetzt";
             }
            return(rewer);

         }
         zeimen++;
       }
      /** Wandelt ein Array von Intwerten in einen zusammenhaengenden String von Binaerwerten um */

      intToBin(satzteil, unkodiert);
      coden(schluessel, unkodiert, kodiert);
      /** Wandelt ein zusammenhängendes Array von Binärwerten in einzelne Int-Werte um */
      binToint(kodiert, satzgecodet);   //zerlege zielbyte-Array wieder in bytes
              //einzeln zielbytes abspeichern
       for (sleib = 0; sleib < toprange / 8; sleib++)
        {
         fputc(satzgecodet[sleib], tar);
         written++;
        }

    }

//eingelesen:
            fclose(src);
            fclose(tar);

            dummy = rewer;
            cout << "\nGelesene Bytes: " << zeimen << "    Geschriebene Bytes: " << written;
            if (kodieren == 1)
             {
              dummy = truncate(zieldatei, orginaldateilaenge);
              cout << endl << "Zieldatei " << zieldatei << " auf " << orginaldateilaenge << " Bytes gesetzt";
             }
             else if (kodieren == 0)
             {
              dummy = truncate(quelldatei, orginaldateilaenge);
              cout << endl << "Quelldatei " << quelldatei << " auf " << orginaldateilaenge << " Bytes gesetzt";
             }
return(rewer);
}

/** Modifiziert die zu chiffrierende Datei */
long Talarius::GetDatValues(int abfragemodus)
 {
  long rewer = 0L;

     dateilaenge = getdatlen(0);
     if (dateilaenge == 0L)
      {
       cout << "Keine solche Datei vorhanden" << endl;
       return(rewer);
      }
     bloecke = (dateilaenge *8) / (long)toprange;
     blockrest = (int)((dateilaenge * 8) % (long)toprange);
     blockdifferenz = (toprange - blockrest) / 8;
     //difbytes = GenRandomByts();
     orginaldateilaenge = dateilaenge;

     cout << "\nToprange.. .......: " << toprange << " Bit";
     cout << "\nDateilänge........: " << dateilaenge << " Bytes ";
     cout << "\nDateilänge in Bit : " << (dateilaenge * 8);
     cout << "\nDateiläenge x 8 / Obergrenze = Bloecke = " << bloecke << " Blöcke";
     cout << "\nRest: " << blockrest << " Bit";
     cout << "\nDifferenz zu toprange: " << blockdifferenz << "Bytes\n";

     if (blockdifferenz != 0)
      {
       cout << "\nErzeuge fehlende Bytes.....";
       difbytes = GenRandomByts();
       cout << "\nErzeugte Fehlbytes: " << difbytes;

       // Speichert die Orginale Dateilänge in der Schlüsseldatei
       showKeyfilename(); // Ausbessern, da die Quelldateilänge gezeigt wird!!
       dummy = SaveOrgDatlen(orginaldateilaenge);
       cout << "\nHänge fehlende Bytes an " << datname << " an";
       dummy = SetDifBytesInFile();

       cout << "\nNeue Dateilänge ermitteln\n";
       //CopyToDatname(dateiname);
       dateilaenge = getdatlen(0);
       rewer = dateilaenge;
       cout << "\nNeue Dateilänge von  " << datname << " :  " << dateilaenge << " Bytes " << endl;
      }

 return rewer;
 }
/** Stellt fest wie lange die Schluesseldatei ist und errechnet daraus die Permutationstiefe, setzt dann toprange und
  * errechnet daraus falls die Datei schon benutzt wurde, die Orginaldateilänge */
int Talarius::keyDateitest(void)
{
  int keyfiletest[12] = {32768, 16384, 8192, 4096, 2048, 1024, 512, 256, 128, 64, 32, 16};
   cout << "Teste Schlüsseldatei mit " << dateilaenge << " Bytes" << endl;
   for (slei = 0; slei < 12; slei++)
    {
    if ((dateilaenge - 4) == (keyfiletest[slei] * 4))
     {
       toprange = (int)((dateilaenge -4)/ 4);
       dummy = GetOrgDatlen(&orginaldateilaenge);
       cout << endl << "Schlüsseldatei mit Orginaldateilänge!" << endl;
       cout << "Orginaldateilänge der Quelldatei: " << orginaldateilaenge << " Bytes" << endl;
       cout << "ACHTUNG: Diese Schlüsseldatei wurde zum Kodieren bereits benutzt" << endl;
       break;
     }
     else if (dateilaenge == (keyfiletest[slei] * 4))
     {
       toprange = (int)((dateilaenge)/ 4);
       cout << endl << "Diese Schlüsseldatei ist noch ohne Dateilängenanhang" << endl;
       break;
     }
     else
     {
     toprange = keyfiletest[slei];
     cout << "keyfiletest  " << toprange<< endl;
     }
    }
     cout << "\nToprange vor dem Einlesen: " << toprange;
return toprange;
}

int Talarius::setiskeyfile(int wert)
 {
  iskeyfile = wert;
  return iskeyfile;
 }

int Talarius::getiskeyfile(void)
{
 return iskeyfile;
}

/** Generiert die Zufallszahlen */
void Talarius::SetRandomValues(void)
{
  initarreale();

      dmog = gettoprange();
      sleia = 0;
     // Nur für Testzwecke
     //for (slei = 0; slei < toprange; slei++)
     // schluessel[slei] = slei;

      for (slei = 0; slei < toprange; slei++)
       {
        zuzaar[slei] = longrand(untergrenze, dmog); // alt war getrand
        kuerzearreal(zuzaar[slei]);
        sleia++;
        dmog--;
        if (dmog == 0 ) break;
       }

}

/** Liest die Schlüsseldatei ein */
long Talarius::RedKeyFileIn(void)
{
 long rewer = 0L;
 cout << "\nDatei für Schlüsselarreal einlesen" << endl;
     GetKeyDateiname();
     rewer = getdatlen(3);
     keyfilelength = rewer;
     if (rewer != -1)
     {
      showKeyfilename();
      toprange = keyDateitest();
      toprange = lesedateiein();
      //taurus.settoprange(toprange);
      testeareal();
      iskeyfile = 3;
     }
     else
      cout << "Fehler bei Dateiöffnen von " << keyfilename<< endl;

 return rewer;
}

/** Speichert die Permutierte Zahlenreihe in schlüsseldatei ab */
void Talarius::SaveKeyFile(void)
 {
  cout << "\nSchluesselarreal sichern\n";
      if (iskeyfile == 0)
        cout << "\nKeine Schlüsselzahlen erzeugt, abspeichern nicht möglich";
       else
       {
        cout << "\nStatus von initrandom: " << initrandom;
        GetKeyDateiname();
        iskeyfile = 2;
        schreibedatei();
       }
 }

/** Lest vom Filestream 4 Bytes als 4Byte-Integer ein */
int fgetDWORD(FILE *fz)
{
 int slei, DWTeile[4] = {0,0,0,0};
 unsigned long dummy = 0;

 for (slei = 3; slei >= 0; slei--)
  {
   DWTeile[slei] = fgetc(fz);
    if ( (feof(fz)) == 0)
     {
      dummy = (unsigned long)DWTeile[0];
      dummy += (unsigned long)(DWTeile[1] << 8);
      dummy += (unsigned long)(DWTeile[2] << 16);
      dummy += (unsigned long)(DWTeile[3] << 24);
     }
  }
return dummy;
}


int fputDWORD(unsigned int letter, FILE *ftw)
{
 int slei, rewer = 0;
 unsigned int DWTeile[4] = {0,0,0,0};

 DWTeile[3] = (letter >> 24);
 DWTeile[2] = ((letter >> 16) & 255);
 DWTeile[1] = ((letter >>  8) & 255);
 DWTeile[0] = (letter & 255);

 for (slei = 3; slei >= 0; slei--)
  rewer = fputc(DWTeile[slei], ftw);

return rewer;
}

void Talarius::getdatname(int kopiermodus)
{
 //int slei = 0;
 cin >> datname;
if (kopiermodus != 0)
 {
  ResetFileNames(quelldatei);
  while((datname[slei]) != '\0')
  {
   if (kopiermodus == 1)
    quelldatei[slei] = datname[slei];
   slei++;
  }
 }
}
/** Kopiert den Dateinamen in dateiname zur Variable datname */
void Talarius::CopyfromDatname(char dateiname[])
{
 int slei = 0;
 while((datname[slei]) != '\0')
  {
   dateiname[slei] = datname[slei];
   dateiname[slei + 1] = '\0';
   slei++;
  }
}
void Talarius::ResetFileNames(char FileNames[])
{
int i;
for (i = 0; i < 150; i++)
 FileNames[i] = 0;
}
