#ifndef TALARIUS_H_INCLUDED
#define TALARIUS_H_INCLUDED

class Talarius
{
 public:
  Talarius(void);
  ~Talarius();
  void Hauptmenue(void);
  int  setToprange(void);
  void initarreale(void);
  void kuerzearreal(int zuza);
  int  gettoprange(void);
  void settoprange(int og);
  void testeareal();
  int  lesedateiein(void);
  int  schreibedatei(void);
  int  getrand (int lowerlimit, int upperlimit);
  int  longrand(long minimum, long maximum);
  long getdatlen(int welchedatei);
  void intzuchar(int zuza, unsigned char (*intteile)[4]);
  unsigned int charzuint(unsigned char intteile[4]);
  void zeigezahlen(int zuzaar[], int zuzalimit, char (*titel));
  void zeigearreal(void);
  void buzubin(unsigned char letter, unsigned char wort[]);
  void binzuza(unsigned int (*letter), unsigned char wort[]);
  void DWto4int(unsigned long wd, unsigned int (*DWTeile)[6]);
  void FourinttoDW(unsigned int DWTeile[], unsigned long (*wd));
  int  SaveOrgDatlen(unsigned long srcdatlen);
  int  GetOrgDatlen(long (*datlen));
  int  atoint(char letter);
  int  SetDifBytesInFile(void);
  int  GenRandomByts(void);
  void intToBin(unsigned char quelle[], unsigned char binsatz[]);
  void binToint(unsigned char binsatz[], unsigned char ziel[2200]);
  int getfilnames(int abfragemodus);
  int  loadSRCDatei(void);
  void coden(unsigned int key[], unsigned char unkodiert[], unsigned char kodiert[]);
  void CopyToDatname(char dateiname[]);
  void KodierFrage(void);
  void GetKeyDateiname(void);
  void showKeyfilename(void);
  void getdatname(int kopiermodus);
  long GetDatValues(int abfragemodus);
  int  keyDateitest(void);
  int  setiskeyfile(int wert);
  int  getiskeyfile(void);
  void SetRandomValues(void);
  long RedKeyFileIn(void);
  void SaveKeyFile(void);
  void CopyfromDatname(char dateiname[]);
  void ResetFileNames(char FileNames[]);
  int  initrandom;
  char quelldatei[150], zieldatei[150], datname[150], keyfilename[150];
  int kodieren; //, fehlbytes[2200];
  int *fehlbytes;
  unsigned char *satzgecodet;
  unsigned char *satzteil;
  unsigned char *unkodiert;
  unsigned char *kodiert;
  int toprange;
  unsigned int *zuzaar;// = new unsigned int[2200]; // 2200 Byte auf dem Heap allozieren
  //unsigned int zuzaar[2200],
  unsigned int *schluessel;
  unsigned int *wuerfel;

 private:
  int dummy, slei, sleia, dmog, iskeyfile;
  long dateilaenge, bloecke, blockrest, blockdifferenz, difbytes, orginaldateilaenge;

  //unsigned int schluessel[2200], wuerfel[2200], stelle;
  int untergrenze, zeimen;
  int zuza, zeigen;
  long keyfilelength;

};

/* Liest ein 4Byte-Integer zerlegt in einzelne Bytes ein */
int fgetDWORD(FILE *fz);
/* Schreibt ein 4Byte-Integer als einzelne Bytes*/
int fputDWORD(unsigned int letter, FILE *ftw);

#endif // TALARIUS_H_INCLUDED
